## libvigraimpex 1.10.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

##################################################
#
#     basic initializations
#
##################################################

PROJECT(vigra)

# read the current version from configVersion.hxx
file(READ ${vigra_SOURCE_DIR}/include/vigra/configVersion.hxx VIGRA_VERSION_FILE)
string(REGEX MATCH "VIGRA_VERSION_MAJOR[ \t\n]+[^ \t\n]+" VIGRA_VERSION_MAJOR ${VIGRA_VERSION_FILE})
string(REGEX REPLACE "VIGRA_VERSION_MAJOR[ \t\n]" "" VIGRA_VERSION_MAJOR ${VIGRA_VERSION_MAJOR})
string(REGEX MATCH "VIGRA_VERSION_MINOR[ \t\n]+[^ \t\n]+" VIGRA_VERSION_MINOR ${VIGRA_VERSION_FILE})
string(REGEX REPLACE "VIGRA_VERSION_MINOR[ \t\n]" "" VIGRA_VERSION_MINOR ${VIGRA_VERSION_MINOR})
string(REGEX MATCH "VIGRA_VERSION_PATCH[ \t\n]+[^ \t\n]+" VIGRA_VERSION_PATCH ${VIGRA_VERSION_FILE})
string(REGEX REPLACE "VIGRA_VERSION_PATCH[ \t\n]" "" VIGRA_VERSION_PATCH ${VIGRA_VERSION_PATCH})

SET(vigra_version_short ${VIGRA_VERSION_MAJOR}.${VIGRA_VERSION_MINOR})
SET(vigra_version ${VIGRA_VERSION_MAJOR}.${VIGRA_VERSION_MINOR}.${VIGRA_VERSION_PATCH})
message(STATUS "Configuring VIGRA version ${vigra_version}")

SET(CMAKE_MODULE_PATH  ${CMAKE_MODULE_PATH}  ${vigra_SOURCE_DIR}/config)

include(VigraSetDefaults)
include(VigraCMakeUtils)

INCLUDE_DIRECTORIES(${vigra_SOURCE_DIR}/include)

IF(VIGRA_STATIC_LIB)
    SET(LIBTYPE STATIC)
    ADD_DEFINITIONS(-DVIGRA_STATIC_LIB)
ELSE(VIGRA_STATIC_LIB)
    SET(LIBTYPE SHARED)
ENDIF(VIGRA_STATIC_LIB)

IF (MSVC)
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE -D_SCL_SECURE_NO_DEPRECATE)
ENDIF ()

# if(CMAKE_COMPILER_IS_GNUCXX)
  # exec_program(
      # ${CMAKE_CXX_COMPILER}
      # ARGS                    --version
      # OUTPUT_VARIABLE _compiler_output)
  # string(REGEX REPLACE ".*([0-9]\\.[0-9]\\.[0-9]).*" "\\1"  gcc_compiler_version ${_compiler_output})
  # if(gcc_compiler_version VERSION_LESS "4.4.0")
      # message(FATAL_ERROR "VIGRA requires at least gcc 4.4")
  # else()
      # message(STATUS "Using gcc ${gcc_compiler_version} [${CMAKE_CXX_COMPILER}]")
  # endif()
# endif()

##################################################
#
#     search for dependencies
#
##################################################

INCLUDE(VigraFindPackage)
VIGRA_FIND_PACKAGE(TIFF NAMES libtiff)
VIGRA_FIND_PACKAGE(JPEG NAMES libjpeg)
VIGRA_FIND_PACKAGE(PNG)
VIGRA_FIND_PACKAGE(FFTW3 NAMES libfftw3-3 libfftw-3.3)
VIGRA_FIND_PACKAGE(FFTW3F NAMES libfftw3f-3 libfftwf-3.3)

IF(WITH_OPENEXR)
    VIGRA_FIND_PACKAGE(OpenEXR)
ENDIF()

IF(WITH_HDF5)
    VIGRA_FIND_PACKAGE(HDF5)
ENDIF()

IF(WITH_BOOST_GRAPH)
    IF(WITH_VIGRANUMPY)
        VIGRA_FIND_PACKAGE( Boost 1.40.0 COMPONENTS python )
    else()
        VIGRA_FIND_PACKAGE( Boost 1.40.0 )
    endif()
ENDIF()

IF(WITH_LEMON)
    VIGRA_FIND_PACKAGE(LEMON)
ENDIF()

SET(DOXYGEN_SKIP_DOT TRUE)
FIND_PACKAGE(Doxygen)
FIND_PACKAGE(PythonInterp)

IF(WITH_VIGRANUMPY)
    FIND_PACKAGE( VIGRANUMPY_DEPENDENCIES )
ENDIF()

IF(WITH_VALGRIND)
    FIND_PROGRAM(VALGRIND_EXECUTABLE valgrind)
ENDIF()

##################################################
#
#     setup testing environment
#
##################################################

ADD_CUSTOM_TARGET(check)
ADD_CUSTOM_TARGET(ctest COMMAND ${CMAKE_CTEST_COMMAND})

ADD_CUSTOM_TARGET(check_cpp)
ADD_DEPENDENCIES(check check_cpp)


OPTION(CREATE_CTEST_TARGETS "Create special targets for CTest" OFF)
IF(CREATE_CTEST_TARGETS)
  INCLUDE(CTest)
ENDIF()

IF(WITH_VIGRANUMPY)
    ADD_CUSTOM_TARGET(check_python)
    ADD_DEPENDENCIES(check check_python)
ENDIF()

ENABLE_TESTING()

##################################################
#
#     setup documentation generator
#
##################################################

ADD_CUSTOM_TARGET(doc)

# Automatically push the latest documentation to github's gh-pages.
# This only works when ${DOCDIR} refers to a VIGRA repository that is 
# checked out in branch 'gh-pages', and the present repository is 
# in branch 'master' (these conditions are checked in the script).
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

    configure_file(${PROJECT_SOURCE_DIR}/config/update-gh-pages.sh.in 
                   ${PROJECT_BINARY_DIR}/update-gh-pages.sh @ONLY)
    EXECUTE_PROCESS(COMMAND chmod u+x ${PROJECT_BINARY_DIR}/update-gh-pages.sh OUTPUT_QUIET ERROR_QUIET)
       
    ADD_CUSTOM_TARGET(gh-pages 
          ${PROJECT_BINARY_DIR}/update-gh-pages.sh
          DEPENDS doc
          WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
          COMMENT "Pushing documentation to github pages.")
endif()

##################################################
#
#     setup private experimentation target
#
##################################################

ADD_CUSTOM_TARGET(experiments)

##################################################
#
#     subdirectories
#
##################################################

ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(test)
ADD_SUBDIRECTORY(docsrc)

IF(WITH_VIGRANUMPY)
    ADD_SUBDIRECTORY(vigranumpy)
ENDIF()

IF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/private/CMakeLists.txt)
    ADD_SUBDIRECTORY(private EXCLUDE_FROM_ALL)
ENDIF()


set(LIB_SUFFIX "" CACHE STRING "Define suffix of lib directory name (32/64)" )

##################################################
#
#     global installation commands
#
##################################################

INSTALL(DIRECTORY ${PROJECT_SOURCE_DIR}/include/vigra
        DESTINATION include)

##################################################
#
#     enable CPack package generation
#
##################################################
INCLUDE(CPackConfig)

##################################################
#
#     add target vigra-$version-src.tar.gz
#
##################################################

find_program(GIT_EXECUTABLE 
              NAMES git git.exe git.cmd
              HINTS $ENV{ProgramFiles}/Git/bin
              DOC "git command line client")

CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/package-src.cmake.in
                ${PROJECT_BINARY_DIR}/package-src.cmake
                @ONLY IMMEDIATE)

add_custom_target(PACKAGE_SRC_TAR
                   COMMAND ${CMAKE_COMMAND} -P package-src.cmake
                   WORKING_DIRECTORY "${PROJECT_BINARY_DIR}"
                   COMMENT "Creating ${PROJECT_BINARY_DIR}/vigra-${vigra_version}-src.tar.gz")        

ADD_DEPENDENCIES(PACKAGE_SRC_TAR check)
ADD_DEPENDENCIES(PACKAGE_SRC_TAR doc_cpp)
IF(WITH_VIGRANUMPY AND PYTHON_SPHINX)
    ADD_DEPENDENCIES(PACKAGE_SRC_TAR doc_python)
ENDIF()

##################################################
#
#  enable other non-CMake projects to find Vigra
#
##################################################

IF(NOT WIN32)
# vigra-config script for (non-CMake-based) third party packages
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/vigra-config.in
        ${PROJECT_BINARY_DIR}/bin/vigra-config
        @ONLY IMMEDIATE)
INSTALL(FILES ${PROJECT_BINARY_DIR}/bin/vigra-config
        DESTINATION bin
        PERMISSIONS
            OWNER_READ OWNER_WRITE OWNER_EXECUTE
            GROUP_READ GROUP_EXECUTE
            WORLD_READ WORLD_EXECUTE)
ENDIF(NOT WIN32)

##################################################
#
#     enable other CMake projects to find Vigra
#
##################################################

# config file for CMake FIND_PACKAGE command (for using the build tree)
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfigBuild.cmake.in
        ${PROJECT_BINARY_DIR}/VigraConfig.cmake
        @ONLY IMMEDIATE)
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfigVersion.cmake.in
        ${PROJECT_BINARY_DIR}/VigraConfigVersion.cmake
        @ONLY IMMEDIATE)

# config file for CMake FIND_PACKAGE command
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfig.cmake.in
        ${PROJECT_BINARY_DIR}/lib/vigra/CMake/VigraConfig.cmake
        @ONLY IMMEDIATE)
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfigVersion.cmake.in
        ${PROJECT_BINARY_DIR}/lib/vigra/CMake/VigraConfigVersion.cmake
        @ONLY IMMEDIATE)

# export targets:
INSTALL(EXPORT vigra-targets
        DESTINATION lib${LIB_SUFFIX}/vigra)
INSTALL(FILES ${PROJECT_BINARY_DIR}/lib/vigra/CMake/VigraConfig.cmake
            ${PROJECT_BINARY_DIR}/lib/vigra/CMake/VigraConfigVersion.cmake
        DESTINATION lib${LIB_SUFFIX}/vigra)
EXPORT(TARGETS vigraimpex FILE vigra-targets.cmake)

##################################################
#
#     status output
#
##################################################

MESSAGE( STATUS "---------------------------------------------------------" )
MESSAGE( STATUS "VIGRA configuration information:" )
MESSAGE( STATUS "---------------------------------------------------------" )

IF(TIFF_FOUND)
    MESSAGE( STATUS "  Using TIFF libraries: ${TIFF_LIBRARIES}" )
ELSE()
    MESSAGE( STATUS "  TIFF libraries not found (TIFF support disabled)" )
ENDIF()

IF(JPEG_FOUND)
    MESSAGE( STATUS "  Using JPEG libraries: ${JPEG_LIBRARIES}" )
ELSE()
    MESSAGE( STATUS "  JPEG libraries not found (JPEG support disabled)" )
ENDIF()

IF(PNG_FOUND)
    MESSAGE( STATUS "  Using PNG  libraries: ${PNG_LIBRARIES}" )
ELSE()
    MESSAGE( STATUS "  PNG libraries not found (PNG support disabled)" )
ENDIF()

IF(OPENEXR_FOUND)
    MESSAGE( STATUS "  Using OpenEXR  libraries: ${OPENEXR_LIBRARIES}" )
ELSEIF(NOT WITH_OPENEXR)
    MESSAGE( STATUS "  OpenEXR disabled by user (WITH_OPENEXR=0)" )
ELSE()
    MESSAGE( STATUS "  OpenEXR libraries not found (OpenEXR support disabled)" )
ENDIF()

IF(FFTW3_FOUND)
    MESSAGE( STATUS "  Using FFTW libraries: ${FFTW3_LIBRARIES}" )
ELSE()
    MESSAGE( STATUS "  FFTW libraries not found (FFTW support disabled)" )
ENDIF()

IF(HDF5_FOUND)
    MESSAGE( STATUS "  Using HDF5 libraries: ${HDF5_LIBRARIES}" )
ELSEIF(NOT WITH_HDF5)
    MESSAGE( STATUS "  HDF5 disabled by user (WITH_HDF5=0)" )
ELSE()
    MESSAGE( STATUS "  HDF5 libraries not found (HDF5 support disabled)" )
ENDIF()

IF(Boost_FOUND)
    MESSAGE( STATUS "  Using Boost Graph Library: ${Boost_INCLUDE_DIR}/boost/graph" )
ELSEIF(NOT WITH_BOOST_GRAPH)
    MESSAGE( STATUS "  Boost Graph Library disabled by user (WITH_BOOST_GRAPH=0)" )
ELSE()
    MESSAGE( STATUS "  Boost Graph Library not found (support disabled)" )
ENDIF()

IF(LEMON_FOUND)
    MESSAGE( STATUS "  Using LEMON graph library: ${LEMON_LIBRARY}" )
ELSEIF(NOT WITH_LEMON)
    MESSAGE( STATUS "  LEMON graph library disabled by user (WITH_LEMON=0)" )
ELSE()
    MESSAGE( STATUS "  LEMON graph library not found (support disabled)" )
ENDIF()

IF(WITH_VIGRANUMPY)
    IF(VIGRANUMPY_DEPENDENCIES_FOUND)
        MESSAGE( STATUS "  Using Python libraries: ${VIGRANUMPY_LIBRARIES}" )
        MESSAGE( STATUS "  Using Numpy includes:   ${PYTHON_NUMPY_INCLUDE_DIR}" )
    ELSE()
        MESSAGE( STATUS "  Vigranumpy dependencies not found (vigranumpy disabled)" )
    ENDIF()
ELSE()
  MESSAGE( STATUS "  Vigranumpy disabled by user (WITH_VIGRANUMPY=0)" )
ENDIF()

MESSAGE( STATUS "---------------------------------------------------------" )

IF(VIGRA_STATIC_LIB)
    MESSAGE( STATUS "  building static lib" )
ELSE()
    MESSAGE( STATUS "  building shared lib" )
ENDIF()

MESSAGE( STATUS "  binaries will be generated in: ${CMAKE_CURRENT_BINARY_DIR}")
IF(DOXYGEN_FOUND AND PYTHONINTERP_FOUND)
    MESSAGE( STATUS "  manuals will be generated in: ${DOCDIR}")
ENDIF()

MESSAGE( STATUS "---------------------------------------------------------" )

MESSAGE( STATUS "  includes will be installed at: ${CMAKE_INSTALL_PREFIX}/include")
MESSAGE( STATUS "  libraries will be installed at: ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")

IF (MSVC)
  MESSAGE( STATUS "  binaries and DLLs will be installed at: ${CMAKE_INSTALL_PREFIX}/bin")
else()
  MESSAGE( STATUS "  binaries will be installed at: ${CMAKE_INSTALL_PREFIX}/bin")
endif()

IF(DOXYGEN_FOUND AND PYTHONINTERP_FOUND)
  MESSAGE( STATUS "  vigra manuals will be installed at: "
    "${CMAKE_INSTALL_PREFIX}/${DOCINSTALL}/vigra/index.html")
ELSE()
  MESSAGE( STATUS "  vigra manuals cannot be generated (Doxygen or Python not found)")
ENDIF()

=== src/CMakeLists.txt ===
ADD_SUBDIRECTORY(impex)
ADD_SUBDIRECTORY(examples)

=== test/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/include)

INCLUDE(VigraAddTest)

ADD_SUBDIRECTORY(error)
ADD_SUBDIRECTORY(impex)
ADD_SUBDIRECTORY(utilities)
ADD_SUBDIRECTORY(pixeltypes)
ADD_SUBDIRECTORY(colorspaces)
ADD_SUBDIRECTORY(classifier)
ADD_SUBDIRECTORY(imgproc)
ADD_SUBDIRECTORY(functorexpression)
ADD_SUBDIRECTORY(convolution)
ADD_SUBDIRECTORY(morphology)
ADD_SUBDIRECTORY(fourier)
ADD_SUBDIRECTORY(math)
ADD_SUBDIRECTORY(optimization)
ADD_SUBDIRECTORY(tensorimaging)
ADD_SUBDIRECTORY(simpleanalysis)
ADD_SUBDIRECTORY(image)
ADD_SUBDIRECTORY(multiarray)
ADD_SUBDIRECTORY(multiconvolution)
ADD_SUBDIRECTORY(voxelneighborhood)
ADD_SUBDIRECTORY(volumelabeling)
ADD_SUBDIRECTORY(watersheds3d)
ADD_SUBDIRECTORY(multidistance)
ADD_SUBDIRECTORY(multimorphology)
ADD_SUBDIRECTORY(seededRegionGrowing3d)
ADD_SUBDIRECTORY(sampler)
ADD_SUBDIRECTORY(hdf5impex)
ADD_SUBDIRECTORY(sifImport)
ADD_SUBDIRECTORY(features)
ADD_SUBDIRECTORY(unsupervised)
ADD_SUBDIRECTORY(coordinateiterator)
ADD_SUBDIRECTORY(objectfeatures)
ADD_SUBDIRECTORY(slic2d)
ADD_SUBDIRECTORY(gridgraph)

=== vigranumpy/CMakeLists.txt ===
IF(VIGRANUMPY_DEPENDENCIES_FOUND)
    ADD_CUSTOM_TARGET(vigranumpy)
    ADD_DEPENDENCIES(vigranumpy vigraimpex)

    SET(vigranumpy_tmp_dir "${CMAKE_BINARY_DIR}/vigranumpy/vigra")
    FILE(MAKE_DIRECTORY ${vigranumpy_tmp_dir})

    INCLUDE_DIRECTORIES(${VIGRANUMPY_INCLUDE_DIRS})

    # configure boost's autolink magic to use the right library name
    # (default on Windows is a mangled name like 'boost_python-vc110-mt-1_51.lib')
    if("${Boost_PYTHON_LIBRARY}" MATCHES "boost_python\\.lib")
        ADD_DEFINITIONS(-DBOOST_AUTO_LINK_NOMANGLE)
    endif()
        
    IF(HDF5_FOUND)
        ADD_DEFINITIONS(-DHasHDF5 ${HDF5_CPPFLAGS})
        INCLUDE_DIRECTORIES(${HDF5_INCLUDE_DIR})
        SET(VIGRANUMPY_IMPEX_LIBRARIES vigraimpex ${HDF5_LIBRARIES})
    ELSE()
        SET(VIGRANUMPY_IMPEX_LIBRARIES vigraimpex)
    ENDIF(HDF5_FOUND)

    IF(MSVC OR MINGW)
        ADD_DEFINITIONS(-DVIGRA_DLL)
    ENDIF ()
    
    include(VIGRA_ADD_NUMPY_MODULE)

    ADD_SUBDIRECTORY(src)
    ADD_SUBDIRECTORY(lib)
    ADD_SUBDIRECTORY(test)
    ADD_SUBDIRECTORY(docsrc)

    IF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/private/CMakeLists.txt)
        ADD_SUBDIRECTORY(private EXCLUDE_FROM_ALL)
    ENDIF()
    
    IF(PYTHON_PLATFORM MATCHES "^windows$")
        FILE(MAKE_DIRECTORY ${vigranumpy_tmp_dir}/dlls)    
        GET_TARGET_PROPERTY(VIGRAIMPEX_LOCATION vigraimpex LOCATION)
        file(RELATIVE_PATH VIGRAIMPEX_DOCDIR ${vigranumpy_tmp_dir} ${DOCDIR})
        
        CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in
                        ${CMAKE_CURRENT_BINARY_DIR}/setup.py
                        @ONLY)

        add_custom_target(PACKAGE_VIGRANUMPY 
                           COMMAND ${CMAKE_COMMAND} -E copy_directory ${DOCDIR} ${vigranumpy_tmp_dir}/doc
                           COMMAND python setup.py bdist_wininst
                           DEPENDS check
                           WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                           COMMENT "Creating vigranumpy setup in ${CMAKE_CURRENT_BINARY_DIR}/dist")        
    ENDIF()
    
    set(VIGRANUMPY_CONFIG_INSTALL_PATH lib${LIB_SUFFIX}/vigranumpy)
    
    set(VIGRANUMPY_INCLUDE_RELATIVE "")
    foreach(PATH ${CMAKE_INSTALL_PREFIX}/include ${VIGRANUMPY_INCLUDE_DIRS})
        file(RELATIVE_PATH RELPATH ${CMAKE_INSTALL_PREFIX}/${VIGRANUMPY_CONFIG_INSTALL_PATH} ${PATH})
        set(VIGRANUMPY_INCLUDE_RELATIVE ${VIGRANUMPY_INCLUDE_RELATIVE} ${RELPATH})
    endforeach(PATH)
    
    set(VIGRANUMPY_LIBRARIES_RELATIVE "")
    foreach(PATH ${VIGRANUMPY_LIBRARIES})
        if(EXISTS ${PATH})
            file(RELATIVE_PATH RELPATH ${CMAKE_INSTALL_PREFIX}/${VIGRANUMPY_CONFIG_INSTALL_PATH} ${PATH})
            set(VIGRANUMPY_LIBRARIES_RELATIVE ${VIGRANUMPY_LIBRARIES_RELATIVE} ${RELPATH})
        else()
            # If ${PATH} is not referring to a path, it is probably a keyword like 
            # "optimized" or "debug" (e.g. on the Mac). We then pass it on unchanged. 
            set(VIGRANUMPY_LIBRARIES_RELATIVE ${VIGRANUMPY_LIBRARIES_RELATIVE} ${PATH})
        endif()
    endforeach(PATH)
    
    CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigranumpyConfig.cmake.in
            ${PROJECT_BINARY_DIR}/lib/vigranumpy/CMake/VigranumpyConfig.cmake
            @ONLY IMMEDIATE)
    INSTALL(FILES ${PROJECT_BINARY_DIR}/lib/vigranumpy/CMake/VigranumpyConfig.cmake
            DESTINATION ${VIGRANUMPY_CONFIG_INSTALL_PATH})
ENDIF()

=== src/examples/CMakeLists.txt ===
SET(TARGETS 
    convert
    subimage
    invert
    invert_explicitly
    resize
    smooth
    palette
    profile
    pyramid
    edge
    boundarytensor
    watershed
    weightedWatersheds
    voronoi
    total_variation)

ADD_CUSTOM_TARGET(examples)

FOREACH(TARGET ${TARGETS})
    ADD_EXECUTABLE(example_${TARGET} EXCLUDE_FROM_ALL ${TARGET}.cxx)
    ADD_DEPENDENCIES(examples example_${TARGET})
    TARGET_LINK_LIBRARIES(example_${TARGET} vigraimpex)
ENDFOREACH(TARGET)

=== src/impex/CMakeLists.txt ===
IF(JPEG_FOUND)
  ADD_DEFINITIONS(-DHasJPEG)
  INCLUDE_DIRECTORIES(${JPEG_INCLUDE_DIR})
ENDIF(JPEG_FOUND)

IF(PNG_FOUND)
  ADD_DEFINITIONS(-DHasPNG)
  INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})
ENDIF(PNG_FOUND)

IF(TIFF_FOUND)
  ADD_DEFINITIONS(-DHasTIFF)
  INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
ENDIF(TIFF_FOUND)

IF(OPENEXR_FOUND)
  ADD_DEFINITIONS(-DHasEXR)
  INCLUDE_DIRECTORIES(${OPENEXR_INCLUDE_DIR})
ENDIF(OPENEXR_FOUND)

IF(HDF5_FOUND)
  ADD_DEFINITIONS(-DHasHDF5 ${HDF5_CPPFLAGS})
  INCLUDE_DIRECTORIES(${HDF5_INCLUDE_DIR})
ENDIF(HDF5_FOUND)

IF (MSVC OR MINGW)
    IF(NOT VIGRA_STATIC_LIB)
        ADD_DEFINITIONS(-DVIGRA_DLL)
    ENDIF()
ELSEIF(CMAKE_COMPILER_IS_GNUCXX)
    IF(VIGRA_STATIC_LIB)
        ADD_DEFINITIONS(-fPIC -DPIC)
    ENDIF()
ENDIF ()

ADD_LIBRARY(vigraimpex ${LIBTYPE}
    bmp.cxx
    byteorder.cxx
    codecmanager.cxx
    exr.cxx
    gif.cxx
    hdr.cxx
    hdf5impex.cxx
    hdf5_rf_impex.cxx
    iccjpeg.c
    imageinfo.cxx
    jpeg.cxx
    png.cxx
    pnm.cxx
    rgbe.c
    sifImport.cxx
    sun.cxx
    tiff.cxx
    viff.cxx
    void_vector.cxx)

set(SOVERSION 5)  # increment this after changing the vigraimpex library
IF(MACOSX)
    SET_TARGET_PROPERTIES(vigraimpex PROPERTIES VERSION ${SOVERSION}.${vigra_version} 
                         SOVERSION ${SOVERSION} INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
ELSE()
    SET_TARGET_PROPERTIES(vigraimpex PROPERTIES VERSION ${SOVERSION}.${vigra_version} SOVERSION ${SOVERSION})
ENDIF() 

IF(JPEG_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${JPEG_LIBRARIES})
ENDIF(JPEG_FOUND)

IF(PNG_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${PNG_LIBRARIES})
ENDIF(PNG_FOUND)

IF(TIFF_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${TIFF_LIBRARIES})
ENDIF(TIFF_FOUND)

IF(OPENEXR_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${OPENEXR_LIBRARIES})
ENDIF(OPENEXR_FOUND)

IF(HDF5_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${HDF5_LIBRARIES})
ENDIF(HDF5_FOUND)

INSTALL(TARGETS vigraimpex
        EXPORT vigra-targets
        RUNTIME DESTINATION bin 
        LIBRARY DESTINATION lib${LIB_SUFFIX} 
        ARCHIVE DESTINATION lib${LIB_SUFFIX})

=== test/error/CMakeLists.txt ===
VIGRA_ADD_TEST(test_error test.cxx)

=== test/features/CMakeLists.txt ===
if(FFTW3_FOUND)
    INCLUDE_DIRECTORIES(${FFTW3_INCLUDE_DIR})

    VIGRA_ADD_TEST(test_features test.cxx LIBRARIES vigraimpex ${FFTW3_LIBRARIES})

    # VIGRA_COPY_TEST_DATA(ghouse.gif)
else()
    MESSAGE(STATUS "** WARNING: test_features will not be executed")
endif()

=== test/fourier/CMakeLists.txt ===
if(FFTW3_FOUND)
    INCLUDE_DIRECTORIES(${FFTW3_INCLUDE_DIR})

    VIGRA_ADD_TEST(test_fourier test.cxx LIBRARIES vigraimpex ${FFTW3_LIBRARIES})

    VIGRA_COPY_TEST_DATA(ghouse.gif filter.xv gaborresult.xv)
else()
    MESSAGE(STATUS "** WARNING: test_fourier will not be executed")
endif()

=== test/gridgraph/CMakeLists.txt ===
VIGRA_ADD_TEST(test_gridgraph test.cxx)

if(WITH_BOOST_GRAPH)
    VIGRA_ADD_TEST(test_gridgraph_BGL test.cxx LIBRARIES ${Boost_GRAPH_LIBRARY})
    INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
    SET_TARGET_PROPERTIES(test_gridgraph_BGL PROPERTIES COMPILE_FLAGS "-DWITH_BOOST_GRAPH")
endif()

if(WITH_LEMON)
    VIGRA_ADD_TEST(test_gridgraph_LEMON test.cxx LIBRARIES ${LEMON_LIBRARY})
    INCLUDE_DIRECTORIES(${LEMON_INCLUDE_DIR})
    SET_TARGET_PROPERTIES(test_gridgraph_LEMON PROPERTIES COMPILE_FLAGS "-DWITH_LEMON")
endif()

=== test/imgproc/CMakeLists.txt ===
VIGRA_ADD_TEST(test_imgproc test.cxx LIBRARIES vigraimpex)

VIGRA_COPY_TEST_DATA(lenna128.xv lenna128rgb.xv splineimageview2.xv splineimageview3.xv splineimageview5.xv lenna42lin.xv lenna288neu.xv lenna42neu.xv lenna288rgbneu.xv lenna42rgbneu.xv lenna367FIR.xv lenna42FIR.xv lenna367IIR.xv lenna42IIR.xv lenna42linrgb.xv lennargb42FIR.xv lennargb42IIR.xv lenna_rotate.xv)

=== test/impex/CMakeLists.txt ===
IF(JPEG_FOUND)
  ADD_DEFINITIONS(-DHasJPEG)
ENDIF(JPEG_FOUND)

IF(PNG_FOUND)
  ADD_DEFINITIONS(-DHasPNG)
ENDIF(PNG_FOUND)

IF(TIFF_FOUND)
  ADD_DEFINITIONS(-DHasTIFF)
  INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
ENDIF(TIFF_FOUND)

IF(OPENEXR_FOUND)
  ADD_DEFINITIONS(-DHasEXR)
ENDIF(OPENEXR_FOUND)

VIGRA_ADD_TEST(test_impex test.cxx LIBRARIES vigraimpex)

VIGRA_COPY_TEST_DATA(lenna.xv lenna_gifref.xv lennafloat.xv lennafloatrgb.xv lennargb.xv no-image.txt lenna_0.tif lenna_1.tif lenna_2.tif lenna_masked_color.tif  lenna_masked_gray.tif)

=== debian/changelog ===
libvigraimpex (1.10.0+dfsg-3ubuntu2) trusty; urgency=medium

  * Build with -O2 on ppc64el.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 21 Feb 2014 16:34:51 +0100

libvigraimpex (1.10.0+dfsg-3ubuntu1) trusty; urgency=medium

  * Merge with Debian experimental to fix FTBFS; remaining changes:
    - Remove build dependency on libhdf5-serial-dev (universe).
    - debian/patches/no-hdf5.diff: Comment out additional methods
      requiring HDF5.
    - build using tiff5

 -- Barry Warsaw <barry@ubuntu.com>  Fri, 07 Feb 2014 18:43:30 -0500

libvigraimpex (1.10.0+dfsg-3) experimental; urgency=medium

  * QA upload.
  * Build with -pipe.

 -- Andreas Metzler <ametzler@debian.org>  Mon, 27 Jan 2014 17:27:13 +0100

libvigraimpex (1.10.0+dfsg-2) experimental; urgency=medium

  * QA upload.
  * (Build-)Depend on libhdf5-dev instead of removed transitional package 
    libhdf5-serial-dev. Closes: #735569
  * (Build-)Depend on libtiff-dev instead of transitional package 
    libtiff4-dev.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 18 Jan 2014 16:23:38 +0100

libvigraimpex (1.10.0+dfsg-1) experimental; urgency=low

  * QA upload.
  * Update watchfile.
  * Use xz compression for source tarball.
  * New upstream version.
    + Drop patches previously pulled from upstream
      20_increased-tolerance-tests.diff
      ref-to-temporary-in-Sampler.diff
    + soname bumped, change package name.
    + Filename of upstream README changed.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 07 Dec 2013 19:56:15 +0100

libvigraimpex (1.9.0+dfsg-6ubuntu3) trusty; urgency=low

  * No change rebuild for Boost 1.54 transition.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Tue, 22 Oct 2013 18:08:36 +0100

libvigraimpex (1.9.0+dfsg-6ubuntu2) saucy; urgency=low

  * Fix build failure with multi-arch'd libboost-python.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Sep 2013 22:06:59 +0200

libvigraimpex (1.9.0+dfsg-6ubuntu1) saucy; urgency=low

  * Merge with Debian; remaining changes:
    - Remove build dependency on libhdf5-serial-dev (universe).
    - debian/patches/no-hdf5.diff: Comment out additional methods
      requiring HDF5.
    - debian/libvigraimpex4.symbols: Mark additional HDF5 related symbols
      as optional since these won't appear in the library.
    - build using tiff5

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Fri, 02 Aug 2013 12:50:27 +0100

libvigraimpex (1.9.0-0ubuntu4) saucy; urgency=low

  * Cherry pick a patch from upstream to fix FTBFS against boost1.53 & gcc4.8.
  * Actually apply "Stop using .symbols files, and use dh_makeshlibs -V"
    from 1.8.0+dfsg-2 upload, but using ubuntu version number.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Wed, 22 May 2013 11:52:49 +0100

libvigraimpex (1.9.0-0ubuntu3) saucy; urgency=low

  * No change rebuild for Boost 1.53 transition.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Fri, 26 Apr 2013 19:18:42 +0100

=== debian/control ===
Source: libvigraimpex
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: dpkg-dev (>= 1.15.3~), debhelper (>= 7.0.50~),
  cmake,
  libfftw3-dev, libpng-dev, libjpeg-dev, libtiff5-dev,
  python-all-dev, python-numpy, libboost-python-dev, python-nose,
  libopenexr-dev
Build-Depends-Indep:
  python, python-sphinx, doxygen, texlive-latex-base, ghostscript
Build-Conflicts: autoconf2.13
X-Python-Version: >= 2.5
Standards-Version: 3.9.5
Homepage: http://hci.iwr.uni-heidelberg.de/vigra/

Package: libvigraimpex-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${python:Depends},
  libvigraimpex5 (= ${binary:Version}),
  libfftw3-dev, libpng12-dev, libjpeg-dev, libtiff5-dev
Suggests: libvigraimpex-doc
Description: development files for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment. 
 . 
 This package contains the header and development files needed to
 build programs and packages using VIGRA.

Package: libvigraimpex5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library 
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment. 

Package: libvigraimpex-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: libvigraimpex-dev, python-vigra-doc
Description: Documentation for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment. 
 . 
 This package contains documentation for the VIGRA library.

Package: python-vigra
Section: python
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Recommends: python-qt4
Suggests: python-vigra-doc, python-h5py
Description: Python bindings for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package exports the functionality of the VIGRA library to Python.

Package: python-vigra-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: python-vigra, libvigraimpex-doc
Description: Documentation for Python bindings for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package contains documentation for Python bindings for the VIGRA library.

=== debian/rules ===
#!/usr/bin/make -f

CFLAGS := $(shell env DEB_CFLAGS_MAINT_APPEND=-pipe dpkg-buildflags --get CFLAGS; dpkg-buildflags --get CPPFLAGS)
CXXFLAGS := $(shell env DEB_CXXFLAGS_MAINT_APPEND=-pipe dpkg-buildflags --get CXXFLAGS; dpkg-buildflags --get CPPFLAGS)
LDFLAGS := $(shell env DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed dpkg-buildflags --get LDFLAGS)

# These don't need to be exported and if they are we'll get the flags
# duplicated in the command line.
unexport CFLAGS
unexport CXXFLAGS
unexport LDFLAGS

ifeq ($(DEB_HOST_ARCH_CPU),i386)
  CFLAGS += -ffloat-store
  CXXFLAGS += -ffloat-store
endif
ifeq ($(DEB_HOST_ARCH),ppc64el)
  CFLAGS := $(subst -O3,-O2,$(CFLAGS))
  CXXFLAGS := $(subst -O3,-O2,$(CXXFLAGS))
endif

space = $() $()
here = $(dir $(firstword $(MAKEFILE_LIST)))/..
current_version = $(shell cd $(here) && dpkg-parsechangelog | sed -n -r -e "/Version: (.*)/ { s//\1/p; q; }")
upstream_version = $(firstword $(subst -,$(space),$(current_version)))

cmake_options = \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DCMAKE_VERBOSE_MAKEFILE=ON \
    -DWITH_OPENEXR=ON \
    -DCMAKE_C_FLAGS_RELEASE="$(CFLAGS)" \
    -DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS)" \
    -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)"
cmake_python_options = \
    -DPYTHON_EXECUTABLE=/usr/bin/python$(1) \
    -DPYTHON_INCLUDE_DIR=/usr/include/python$(1)/ \
    -DPYTHON_LIBRARY=$(wildcard /usr/lib/libpython$(1).so /usr/lib/$(DEB_HOST_MULTIARCH)/libpython$(1).so) \
    -DBoost_PYTHON_LIBRARY_RELEASE=/usr/lib/$(DEB_HOST_MULTIARCH)/libboost_python-py$$(echo $(1) | tr -d .).so

# build and build-* targets
# =========================

.PHONY: build build-arch build-indep

build: build-arch build-indep

build-indep:
	# Nothing to do in build-indep, "thanks" to bug #374029.

build-arch:
	dh_testdir
	echo DEBUGMEMSIZE ; if which free ; then free ; fi
	$(MAKE) -f debian/rules \
		obj/CMakeCache.txt \
		$(patsubst %,obj.%/CMakeCache.txt,$(shell pyversions -r))
	$(MAKE) -f debian/rules \
		doc/changelog \
		obj/build-stamp \
		$(patsubst %,obj.%/build-stamp,$(shell pyversions -r))
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
  ifneq (,$(filter $(DEB_HOST_ARCH_CPU),powerpc))
	: # run the tests, but ignore test results
	-$(MAKE) -k -f debian/rules \
		obj/test-stamp \
		$(patsubst %,obj.%/test-stamp,$(shell pyversions -r))
  else
	$(MAKE) -k -f debian/rules \
		obj/test-stamp \
		$(patsubst %,obj.%/test-stamp,$(shell pyversions -r))
  endif
endif

obj/CMakeCache.txt:
	mkdir -p $(dir $(@))
	cd $(dir $(@)) && cmake .. $(cmake_options) \
		-DPYTHON_EXECUTABLE=/usr/bin/python \
		-DWITH_VIGRANUMPY=0

obj.python%/CMakeCache.txt:
	mkdir -p $(dir $(@))
	cd $(dir $(@)) && \
		CXXFLAGS=-fno-strict-aliasing cmake .. $(cmake_options) $(call cmake_python_options,$(*))
	if ! grep VIGRANUMPY_DEPENDENCIES $(@) > /dev/null; then \
		echo "Error: Numpy for Python $* not found" >&2; \
		rm -f $(@); \
		exit 1; \
	fi
	# We don't want to link with libpythonX.Y.
	# We don't want SONAMES (except vigranumpycore.so)
	find $(dir $(@))/vigranumpy/ -name 'link.txt' -exec sed -i \
		-e 's/ -lpython[0-9.]\+ / /g' \
		-e '/-Wl,-soname,vigranumpycore/b' \
		-e 's/ -Wl,-soname,[^ ]\+ / /' \
		{} +

obj/build-stamp: obj/CMakeCache.txt
	$(MAKE) -C $(dir $(@))
	chmod a-x vigranumpy/test/*.py # nosetest would skip executable *.py
	touch $(@)

obj.python%/build-stamp: obj.python%/CMakeCache.txt obj/build-stamp
	cd obj && find . -name '*.o' -o -name '*.so' -o -name '*.so.*' | xargs cp -v --preserve=links --parents -t ../$(dir $(@))
	$(MAKE) -C $(dir $(@))
	touch $(@)

obj/test-stamp: obj/build-stamp
	$(MAKE) check -C $(dir $(@))
	touch $(@)

obj.python%/test-stamp:: obj.python%/build-stamp
	$(MAKE) vigranumpytest -C $(dir $(@))
	touch $(@)

doc/changelog: docsrc/credits_changelog.dxx
	sh debian/convert-changelog.sh < $(<) > $(@)

# binary and binary-* targets
# ===========================

.PHONY: binary binary-arch binary-indep

binary: binary-arch binary-indep

binary-arch: build-arch
	dh_testdir
	dh_testroot
	$(MAKE) -f debian/rules \
		obj/install-stamp \
		$(patsubst %,obj.%/install-stamp,$(shell pyversions -r))
	dh_install -a
	dh_installdocs -a
	dh_installchangelogs -a doc/changelog
	dh_installexamples -a
	find -path './debian/*/usr/share/doc/*/examples/*' -exec chmod a-x '{}' +
	dh_installman -a
	dh_python2 -a
	dh_link -a
	dh_compress -a
	dh_fixperms -a
	dh_strip -a
	dh_makeshlibs -V 'libvigraimpex5 (>= 1.10.0)'
	dh_shlibdeps
	# See <http://lists.debian.org/debian-python/2010/07/msg00042.html>:
	$(or $(wildcard /usr/bin/dh_numpy),debian/dh_numpy) -p python-vigra
	dh_installdeb -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

.PHONY: binary-indep
binary-indep: build-indep
	dh_testdir
	dh_testroot
	$(MAKE) -f debian/rules \
		doc/vigra/build-stamp \
		doc/vigranumpy/build-stamp
	dh_installdocs -i -XLICENSE.txt -Xobjects.inv -Xdoctrees -X.buildinfo -Xbuild-stamp
	cd debian/libvigraimpex-doc/usr/share/doc/libvigraimpex-doc/ && \
		rm -rf html && \
		mv vigra html && \
		rm -f html/jquery.js && \
		sed -r -i \
			-e 's!(<a href=")LICENSE.txt(">)!\1/usr/share/doc/libvigraimpex-doc/copyright\2!g' \
			html/index.html
	cd debian/python-vigra-doc/usr/share/doc/python-vigra-doc/ && \
		rm -rf html && \
		mv vigranumpy html
	dh_installchangelogs -i
	dh_link -i
ifeq "$(wildcard /usr/bin/dh_sphinxdoc)" ""
	echo "sphinxdoc:Depends=libjs-jquery" >> debian/python-vigra-doc.substvars
else
	dh_sphinxdoc -p python-vigra-doc /usr/share/doc/python-vigra-doc/html/
endif
	dh_compress -i -X.js -X_sources
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

%/install-stamp: %/build-stamp
	$(MAKE) -C $(dir $(@)) install DESTDIR=$(CURDIR)/debian/tmp/
	touch $(@)

doc/vigra/build-stamp: obj/build-stamp
	$(MAKE) doc_cpp -C obj/
	touch $(@)

doc/vigranumpy/build-stamp: obj.$(shell pyversions -d)/build-stamp doc/vigra/build-stamp
	ln -sf $(CURDIR)/vigranumpy/docsrc/c_api_replaces.txt obj.$(shell pyversions -d)/vigranumpy/docsrc/
	$(MAKE) doc_python -C obj.$(shell pyversions -d)/
	touch $(@)

# clean target
# ============

.PHONY: clean
clean:
	dh_testdir
	dh_clean
	rm -rf obj*/
	find doc/ -type f -delete

# get-orig-source target
# ======================

.PHONY: get-orig-source
get-orig-source:
	sh $(here)/debian/get-orig-source.sh 1.10.0+dfsg
	#sh $(here)/debian/get-orig-source.sh $(upstream_version)

.NOTPARALLEL:

# vim:ts=4 sw=4 noet

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg[0-9]*// \
http://hci.iwr.uni-heidelberg.de/vigra/ \
(?:.*/)vigra-([\d.]+)-src(?:-with-docu|).tar.gz
